package internal

import (
	"codeup.aliyun.com/6552e56cc3b2728a4557fc18/plugin/proto"
	"encoding/json"
	"plugins/zltx/internal/po"
	"time"
)

func rechargeReq(c *proto.OrderRequest) *po.OrderReq {
	return &po.OrderReq{
		MerchantId:      c.Config.AppId,
		OutTradeNo:      c.Order.OrderNo,
		ProductId:       c.Product.ProductNo,
		RechargeAccount: c.Order.Account,
		AccountType:     1,
		Number:          1,
		Version:         "1.0",
		TimeStamp:       time.Now().Unix(),
		NotifyUrl:       c.Config.NotifyUrl,
	}
}

func rechargeResp(request *proto.OrderRequest, resp po.OrderResp) *proto.OrderResponse {
	data, _ := json.Marshal(resp)
	return &proto.OrderResponse{
		Result: &proto.Result{
			Status:  proto.Status_ING,
			OrderNo: request.Order.OrderNo,
			TradeNo: "", // 下单无该值返回
			Message: resp.Message,
			Data:    data,
		},
	}
}

func queryReq(in *proto.QueryRequest) *po.QueryReq {
	return &po.QueryReq{
		MerchantId: in.Config.AppId,
		OutTradeNo: in.Order.OrderNo,
		TimeStamp:  time.Now().Unix(),
		Version:    "1.0",
	}
}

func queryResp(request *proto.QueryRequest, resp po.QueryResp) *proto.QueryResponse {
	data, _ := json.Marshal(resp)
	return &proto.QueryResponse{
		Result: &proto.Result{
			Status:  resp.Status.GetOrderStatus(),
			OrderNo: request.Order.OrderNo,
			TradeNo: request.Order.TradeNo,
			Message: resp.Message,
			Data:    data,
		},
	}
}

func notifyResp(poReq po.Notify) *proto.NotifyResponse {
	data, _ := json.Marshal(poReq)
	return &proto.NotifyResponse{
		Result: &proto.Result{
			Status:  poReq.Status.GetOrderStatus(),
			OrderNo: poReq.OutTradeNo,
			TradeNo: "",
			Message: "",
			Data:    data,
		},
	}
}
